config/routes.rb
Rails.application.routes.draw do
  resources :line_items
  resources :carts
  resources :cubes
  devise_for :views
  devise_for :users, controllers: {
  	registrations: 'registrations'
  }
  root 'cubes#index'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/cube.rb
class Cube < ApplicationRecord
	before_destroy :not_referenced_by_any_line_item
	belongs_to :user, optional: true
	has_many :line_items

	mount_uploader :image, AvatarUploader # for carrierwave
	serialize :image, JSON # ONLY FOR SQLITE

	validates :title, :brand, :model, :price, :image, presence: true # validates that these line items are non-null
	validates :description, length: {maximum: 1000, too_long: "%{count} characters is the maximum # of chars allowed... cmon man..."}
	validates :title, length: {maximum: 100, too_long: "bro why is your title %{count} chars long... give me a new title"}
	validates :price, length: {maximum: 7}

	BRAND = %w{Moyu Gans Valk Yuxin Dayan Cubicle FangShi}
	FINISH = %w{Matte Glossy Solid Metallic Pearlescent Special}
	CONDITION = %w{New Excellent Mint Used Fair Poor}

	private

	def not_referenced_by_any_line_item
		# if line items not empty, don't throw an error
		unless line_items.empty? 
	      	errors.add(:base, "Line items present")
	     	throw :abort
		end
	end
end

app/controllers/cubes_controller.rb
class CubesController < ApplicationController
  before_action :set_cube, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!, except: [:index, :show]

  # GET /cubes
  # GET /cubes.json
  def index
    @cubes = Cube.all
    # @cubes = Cube.all.order("created_at desc")
  end

  # GET /cubes/1
  # GET /cubes/1.json
  def show
  end

  # GET /cubes/new
  def new
    @cube = Cube.new
    # @cube = current_user.cubes.build
  end

  # GET /cubes/1/edit
  def edit
  end

  # POST /cubes
  # POST /cubes.json
  def create
    @cube = Cube.new(cube_params)
    # @cube = current_user.cubes.build(cube_params)

    respond_to do |format|
      if @cube.save
        format.html { redirect_to @cube, notice: 'Cube was successfully created.' }
        format.json { render :show, status: :created, location: @cube }
      else
        format.html { render :new }
        format.json { render json: @cube.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /cubes/1
  # PATCH/PUT /cubes/1.json
  def update
    respond_to do |format|
      if @cube.update(cube_params)
        format.html { redirect_to @cube, notice: 'Cube was successfully updated.' }
        format.json { render :show, status: :ok, location: @cube }
      else
        format.html { render :edit }
        format.json { render json: @cube.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /cubes/1
  # DELETE /cubes/1.json
  def destroy
    @cube.destroy
    respond_to do |format|
      format.html { redirect_to cubes_url, notice: 'Cube was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_cube
      @cube = Cube.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def cube_params
      params.require(:cube).permit(:brand, :model, :description, :condition, :finish, :title, :price, :image)
    end
end

app/helpers/cubes_helper.rb
module CubesHelper
end

app/views/cubes/_form.html.erb
<%= simple_form_for(@cube) do |f| %>
  <%= f.error_notification %>
  <%= f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present? %>

  <div class="form-inputs">
    <%= f.input :title %>
    <%= f.input :brand %>
    <%= f.input :model %>
    <%= f.input :description %>
    <%= f.input :condition %>
    <%= f.input :finish %>
    <%= f.input :price %>
    <%= f.input :image%>
  </div>

  <div class="form-actions">
    <%= f.button :submit %>
  </div>
<% end %> 

app/views/cubes/edit.html.erb
<% content_for :header do %>
<section class="hero is-warning">
  <div class="hero-body">
    <div class="container">
      <h1 class="title">
        Editing Cube
      </h1>
    </div>
  </div>
</section>
<% end %>

<div class="pv4"> <!-- padding vertical class of scale 4 -->
  <%= render 'form', cube: @cube %> <!-- rendering and passignt through the form, need access to cube -->
</div>

app/views/cubes/index.html.erb
<p id="notice"><%= notice %></p>

<h1 class = 'title is-2'>Cubes for sale</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Brand</th>
      <th>Model</th>
      <th>Description</th>
      <th>Condition</th>
      <th>Finish</th>
      <th>Price</th>
      <th colspan="0"></th>
    </tr>
  </thead>

  <tbody>
    <% @cubes.each do |cube| %>
      <tr>
        <td><%= cube.title %></td>
        <td><%= cube.brand %></td>
        <td><%= cube.model %></td>
        <td><%= cube.description %></td>
        <td><%= cube.condition %></td>
        <td><%= cube.finish %></td>
        <td>$<%= cube.price.to_f %></td>
        <td><%= link_to 'Show', cube, :style=>'color:#2729A2;' %></td>
        <td><%= link_to 'Edit', edit_cube_path(cube), :style=>'color:#2729A2;' %></td>
        <td><%= link_to 'Destroy', cube, :style=>'color:#2729A2;', method: :delete, data: { confirm: 'Are you sure?' } %></td>
        <%# end %>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%#= button_to 'New Cube', new_cube_path, class: 'button is-warning' %>

app/views/cubes/new.html.erb
<% content_for :header do %>
<section class="hero is-warning">
  <div class="hero-body">
    <div class="container">
      <h1 class="title">
        Sell a Rubik's cube
      </h1>
    </div>
  </div>
</section>
<% end %>

<div class="pv4">  <!-- padding vertical class of scale 4 -->
  <%= render 'form', cube: @cube %> <!-- rendering and passignt through the form, need access to cube -->
</div>

<%= link_to 'Back', cubes_path, :style=>'color:#2729A2;' %>

app/views/cubes/show.html.erb
<p id="notice"><%= notice %></p>

 <!-- <p> -->
  <!-- <strong>Sold By: <%#= @cube.user.name %></strong> -->
<!-- </p>   -->

<p>
  <strong>Title:</strong>
  <%= @cube.title %>
</p>

<p>
  <strong>Brand:</strong>
  <%= @cube.brand %>
</p>

<p>
  <strong>Model:</strong>
  <%= @cube.model %>
</p>

<p>
  <strong>Description:</strong>
  <%= @cube.description %>
</p>

<p>
  <strong>Condition:</strong>
  <%= @cube.condition %>
</p>

<p>
  <strong>Finish:</strong>
  <%= @cube.finish %>
</p>

<p>
  <strong>Price:</strong>
  $<%= @cube.price %>
</p>

<p>
  <%= image_tag(@cube.image_url (:thumb)) %>
</p>


<%= link_to 'Edit', edit_cube_path(@cube) %> |
<%= link_to 'Back', cubes_path %>
<div class="center">
<%= button_to 'Add to cart', line_items_path(cube_id: @cube), class: 'button is-warning add-to-cart' %>
</div>


<br>